(function () {

    'use strict';

    var $form = $('#js-form'),
        $data = $form.find('.js-require'),
        $button = $form.find('.button');

    //F ここから
    var validations = {
        user: false,
        comment: false
    }
    //F ここまで

    //A ここから
    function setError(elm){
        elm.addClass('is-error');
    }
    //A ここまで

    //B ここから
    function removeError(elm){
        elm.removeClass('is-error');
        elm.addClass('is-success');
    }
    //B ここまで

    //C ここから
    function keyHandler(self){
        var dataKey = self.data('key');
        var $target = $('#js-form-' + dataKey);
        var val = self.val();
        if(val === ""){
            setError($target);
        } else {
          removeError($target);
        }
    }
    //C ここまで

    //D ここから
    function checkValidations(self) {
        var dataKey = self.data('key');
        var key = self.attr('id').substr(8);
        var val = self.val();
        if(val === ""){
            validations[key] = false;
        } else {
          validations[key] = true;
        }
    }
    //D ここまで

    //E ここから
    function allowButton(){
        if(validations.user === true &&
            validations.comment === true
        ){
            $button.removeClass('is-disable');
        } else {
            $button.addClass('is-disable');
        }
    }
    allowButton();
    //E ここまで

    //G ここから
    $data.on('change keyup focusout', function(){
        keyHandler($(this));
        checkValidations($(this));
        allowButton();
    });
    //G ここまで
})();